#version 430 core
/*
* Copyright 2019 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

//mesh data set through glVertexAttribPointer(); in Mesh.cpp
layout(location = 0) in vec3 aPosition;
layout(location = 1) in vec3 aNormal;
layout(location = 2) in vec2 aUV;
layout(location = 3) in vec3 aColor;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;
uniform mat4 lightViewProjMatrix;

out VertexData {
	vec3 crntPos;
	vec3 normal;
	vec2 uv;
	vec3 color;
	vec4 fragPosDirLight;
} vert;

void main() {
	vec4 position_world_ = modelMatrix * vec4(aPosition, 1);
	
	//output to fragment shader
	vert.crntPos = position_world_.xyz;
	vert.normal = normalMatrix * aNormal;
	vert.uv = aUV;
	vert.color = aColor;
	vert.fragPosDirLight = lightViewProjMatrix * position_world_;
	
	gl_Position = viewProjMatrix * position_world_;
}